/* TIGRE implementation:  HEAP.H */
/* Heap management and garbage collection */
/* Uses stop-and-copy garbage collector */

/* (C) Copyright 1989   Philip Koopman Jr.  */
/*  Last update:  4/17/89   */
/*  Test code version -- not for distribution  */

#include <setjmp.h>
extern jmp_buf env ;
extern int ready_for_longjmp ;  /* true when want a setjmp restart */

#define NEWNODE1                                      \
  temp1 = next_free_node ;                            \
  next_free_node = temp1 + HEAP_STRIDE ;              \
  if( temp1 >= heap_end) temp1 = newnode_continue(temp_spine);

#define NEWNODE2                            \
  temp1 = next_free_node ;                  \
  temp2 = temp1 + HEAP_STRIDE ;             \
  next_free_node = temp1 + 2*HEAP_STRIDE ;    \
  if( temp2 >= heap_end)                    \
    { newnode2_continue(temp_spine,&nodea,&nodeb); \
           temp1=nodea; temp2=nodeb; }

#define NEWNODE3                           \
  temp1 = next_free_node ;                 \
  temp2 = temp1 + HEAP_STRIDE ;            \
  temp3 = temp1 + 2*HEAP_STRIDE ;          \
  next_free_node = temp1 + 3*HEAP_STRIDE ; \
  if( temp3 >= heap_end)                   \
   { newnode3(temp_spine,&nodea,&nodeb,&nodec);       \
                    temp1=nodea; temp2=nodeb; temp3=nodec; }

#define NEWNODEN(x)            \
  temp1 = next_free_node ;     \
  next_free_node = temp1 + HEAP_STRIDE * x ; \
  if( next_free_node >= heap_end) { \
    collect_garbage(temp_spine); \
    temp1 = next_free_node ; \
    next_free_node = temp1 + HEAP_STRIDE * x ; \
    if( next_free_node >= heap_end) { \
      printf("Out of heap!"); \
      exit (-1); \
  } };
