/* NFIB  C code for comparison with TIGRE   NFIB.C */

#include <stdio.h>

#define  UNIX  1

#if UNIX
#include <sys/types.h>
#include <sys/times.h>
/* time measurement definitions */
#define	HZ	60
#define INT_32  int

#else   /* TURBOC time telling, etc. */
#include <time.h>
#include <stdlib.h>
#define	HZ	CLK_TCK
#define INT_32  long

#endif

#if UNIX
/* variables for time measurement: */
struct tms      time_info;
extern long     times (struct tms *time_info);
long            Begin_Time, End_Time;
#else
clock_t		Begin_Time, End_Time;
#endif
float           Seconds, Combinators_Per_Second;

#define TRUE 1
#define FALSE 0

/* ______________________________________________________________________ */
INT_32 sieve_number ; /* state variable for sieve */
INT_32 every_other_number ; /* state variable for every_other */

/* coroutine implementation of nthprime */
/* (define (nth n (hd . tl))
 *   (if (= 0 n)
 *       hd
 *       (nth (- n 1) tl)))
 */
/* (define (every-other n)
 *   (cons n (every-other (+ n 2))))
 */
INT_32 every_other(INT_32 n)
  {  INT_32 newn ;
    newn = n + 2 ;
    return(newn);
  }

/* (define (filter n (first . rest))
 *   (if (= 0 (mod first n))
 *       (filter n rest)
 *       (cons first (filter n rest))))
 */
int filter(INT_32 n)  /* returns truth flag */
  { INT_32 i  ;  /* loop counter */
    int success ; /* truth flag */

    success = TRUE ;
    i = 3 ;
    while ( i < n)
    { /* printf("  filter %d by %d\n",n,i); */
      if ( ( n % i ) ==  0 )
        { success = FALSE ;
          /* printf("break\n");  */
          break ;
        }
      i = every_other(i) ; 
    }
    return(success);
}  

/* (define (sieve (prime . rest))
 *   (cons prime (sieve (filter prime rest))))
 */
INT_32 sieve()
  { INT_32 newn ;
    INT_32 i ; /* loop counter */
    int success ; /* success flag */

    success = FALSE ;
    while ( ! success )
    { sieve_number = every_other(sieve_number) ; 
/*      printf("sieve number= %d\n",sieve_number); */
      success = filter(sieve_number) ; 
    }
    return(sieve_number);
  }

/* (define (nthprime n)
 *   (nth n (cons 2 (sieve (every-other 3)))))
 */
INT_32 nthprime(int n)
 { INT_32 newn;
   int i ;  /* loop counter */

   every_other_number = 3 ;
   sieve_number = 1 ;
   if ( n < 1 )
    { newn = 2 ;
      return(newn);
    }

   for ( i = 1 ; i <= n ; i++)
    { /* printf("-->%dth sieve  \n",i); */
      newn = sieve();
      /* printf("%d %d\n",n,newn); */
    }
   return(newn);
 }


void main(int argc,char *argv[])
  { INT_32 result ;
   int inparam;
   printf("\nnthprime timing program (in C)");

   inparam = 12345 ;
   while ( inparam > 0 )
   {
     printf("\nInput value (0 to stop)?");
     scanf("%d",&inparam);
     printf("input = %d\n",inparam);
     if(feof(stdin))  return ;
     if(inparam == 0) return ;

#if UNIX
       /* Start timer */
       times (&time_info);
       Begin_Time = (long) time_info.tms_utime;
#else
       Begin_Time = clock();
#endif
       /* Evaluate nfib */
       result = nthprime(inparam);
#if UNIX
       /* Stop timer */
       times (&time_info);
       End_Time = (long) time_info.tms_utime;
#else
       End_Time = clock();
#endif
#if VAX
       printf("And the answer is.....%d   ",result);
#else
       printf("And the answer is.....%ld   ",result);
#endif

       /* compute elapsed time */
       Seconds = ((float) (End_Time - Begin_Time) ) / HZ ;
         printf ("\nElapsed time in seconds: %8.3f  ", Seconds);
       printf ("\n");

   }
   return;
  }
