/* TIGRE implementation:  LEXER.H */
/* Lexer for graph reducers */

/* (C) Copyright 1989   Philip Koopman Jr.  */
/*  Last update:  3/1/89   */
/*  Test code version -- not for distribution  */

/* in this compiler, the maximum lexeme length is MAXLEN - 1, since
 *  all lexemes are right-padded with a \0, which is not included
 *  in the returned length.
 */
#define MAXLEN  80

#define ALL    -1313
#define TRUE    1
#define FALSE   0

/* Debugging flags:  if TRUE, print helpful messages */
/*                   (uses conditional compilation)  */
#define   DEBUG_LEXER   FALSE

typedef struct token {            /* Object returned by lexer */
        int toktype;            /* Token type */
        int value;              /* value if an integer */
        int linenum ;   /* line number */
        char toktext[MAXLEN+1];
        int toklen ;  /* length used of toktext */
  } token;

extern void InitLexer();
/*
 * Initialize lexer module.
 * Will be called exactly once before any calls to GetNextToken.
 */
extern void EndLexer();

extern void GetNextToken();
/*
 * On each call, places the next lexeme into the variable tok.
 */
 
