# TIGRE kernel for SPARC chip
# by Phil Koopman Jr.  4/90

# register   usage
#
# i0 - combinator counter
# i1 - free list pointer
# i2 - result returned from eval
# i3 - me_ptr
# i4 - parent_ptr
# i5 - spine_ptr
# i6 - reserved
# i7 - reserved

# l0 - scratch
# l1 - scratch
# l2 - scratch
# l3 - scratch
# l4 - grandparent_ptr
# l5 - spine_start  (for threading spine stack overflow check)
# l6 - heap_end  (for heap allocation range check)
# l7 -

# o0 - 
# o1 - ip
# o2 - 
# o3 -
# o4 -
# o5 -
# o6 -
# o7 - lightweight call's return address

LL0:
	.seg	"data"
	.common	_nodea,0x4,"data"
	.common	_nodeb,0x4,"data"
	.common	_nodec,0x4,"data"
	.common	_breakval,0x4,"data"
	.seg	"text"
	.proc 011
	.global	_Evaluate
_Evaluate:
	!#PROLOGUE# 0
	sethi	%hi(LF83),%g1
	add	%g1,%lo(LF83),%g1
	save	%sp,%g1,%sp
	!#PROLOGUE# 1

	st	%i1,[%fp+0x48]
	sub	%fp,0xc,%o0
	mov	%i0,%o1
	ld	[%o1],%o2
	st	%o2,[%o0+0]
	ld	[%fp+0x48],%i5
	ld	[%fp+-0xc],%o1

	sethi	%hi(_count),%l0		! store counter results
	ld	[%l0+%lo(_count)],%i0

	sethi	%hi(_spine_start),%l5
	ld	[%l5+%lo(_spine_start)],%l5

	sethi	%hi(_next_free_node),%l1
	ld	[%l1+%lo(_next_free_node)],%i1

	sethi	%hi(_heap_end),%l6
	ld	[%l6+%lo(_heap_end)],%l6

	call	MY_EVAL
	nop

	st	%i2,[%fp+-0x4]		! store result into frame

	sethi	%hi(_count),%l0		! store counter results
	st	%i0,[%l0+%lo(_count)]

	sub	%fp,0x4,%o0
	mov	4,%o1
	call	.stret4
	nop

MY_RET:
	ld	[%i5],%o7
	jmpl	%o7+0x8,%g0
	add	%i5,0x4,%i5

MY_EVAL:
	st	%o7,[%i5+-0x4]
	sub	%i5,0x4,%i5

#
# _________________________________________________________________

# threading engine
L86:
THREAD:
# branch if not a pointer
	andcc	%o1,0x1,%g0
	bne	L89
	ld	[%i5],%i3		! Use_Me
#	---

	st	%o1,[%i5+-0x4]
#   while ip is a pointer
L88:
# push ip value (NOT + 4) onto spine stack
	ld	[%o1],%o1		! ip <- [ip]
	add	%i5,-4,%i5
	andcc	%o1,0x1,%g0		! found a non-pointer yet?
	be	L88
	st	%o1,[%i5+-0x4]

# check for spine stack overflow
#  if temp_spine < spine_start   then  spine_overflow()
# jump through table for case statement
	ld	[%i5],%i3		! Use_Me
L89:
	cmp	%i5,%l5
	bgeu	L90
	andn	%o1,1,%o1
#       ----

	call	_spine_overflow,0
	nop

L90:
	jmp	%o1
	add	%i0,1,%i0		! bump combinator counter
#       ---
# _________________________________________________________________

DO_I:
	ld	[%i3+4],%o1		! ip = Rme
	b	THREAD
	add	%i5,0x4,%i5

# _________________________________________________________________

DO_K:
	ld	[%i3+4],%o1		! ip = Rme
	b	THREAD
	add	%i5,0x8,%i5

# _________________________________________________________________

DO_S:
# NEWNODE2
	add	%i1,0x10,%i1
	cmp	%i1,%l6
	bgu	DO_GC

# code for graph rewrite  (((S f) g) x) ->  (f x)(g x)
	ld	[%i5+0x4],%i4		! Use_Parent
	ld	[%i5+0x8],%l4		! Use_Grandparent 
	ld	[%i3+4],%o1		! ip = f
	ld	[%i4+4],%l0		! fetch g into %l0
	ld	[%l4+4],%l1		! fetch x into %l1
	st	%o1,[%i1+-0x10]		! put f in Ltemp1
	st	%l1,[%i1+-0x0c]		! put x in Rtemp1
	std	%l0,[%i1+-0x08]		! put (g x) in temp2
	add	%i1,-0x10,%l0		! put pointers in root node
	add	%i1,-0x08,%l1
	std	%l0,[%l4]
	st	%l0,[%i5+0x4]		! top(temp1)
	b	THREAD
	add	%i5,0x4,%i5		! pop_spine(1)

# -------------------> gc never returns, because of longjmp
DO_GC:
	sethi	%hi(_count),%l0		! store counter results
	st	%i0,[%l0+%lo(_count)]
	
	mov	%i5,%o0
	call	_collect_garbage,1
	nop

# _________________________________________________________________

DO_C:
# NEWNODE1
        add     %i1,0x8,%i1
        cmp     %i1,%l6
        bgu     DO_GC
 
# code for graph rewrite  (((C f) g) x) ->  ((f x) g)
        ld      [%i5+0x4],%i4           ! Use_Parent
        ld      [%i5+0x8],%l4           ! Use_Grandparent
        ld      [%i3+4],%o1             ! ip = f
        ld      [%i4+4],%l1             ! fetch g into %l1
        ld      [%l4+4],%l0             ! fetch x into %l0
        st      %o1,[%i1+-0x8]          ! put f in Ltemp1
        st      %l0,[%i1+-0x4]          ! put x in Rtemp1
        add     %i1,-0x8,%l0		! put temp1/g in root node
        std     %l0,[%l4]
	st	%l0,[%i5+0x4]		! top(temp1)
        b       THREAD
        add     %i5,0x4,%i5             ! pop_spine(1)
 
# _________________________________________________________________
 
DO_B: 
# NEWNODE1
        add     %i1,0x8,%i1 
        cmp     %i1,%l6 
        bgu     DO_GC
  
# code for graph rewrite  (((B f) g) x) ->  (f (g x))
        ld      [%i5+0x4],%i4           ! Use_Parent
        ld      [%i5+0x8],%l4           ! Use_Grandparent
        ld      [%i3+4],%o1             ! ip = f
        ld      [%i4+4],%l0             ! fetch g into %l0
        ld      [%l4+4],%l1             ! fetch x into %l1
        std     %l0,[%i1+-0x8]          ! put (g x) in Ltemp1
        add     %i1,-0x8,%l0            ! put f/temp1 in root node
        st      %o1,[%l4]
        st      %l0,[%l4+4]
        b       THREAD
        add     %i5,0x8,%i5             ! pop_spine(2)
 
# _________________________________________________________________
 
DO_SPRIME:
# NEWNODE3
        add     %i1,0x18,%i1
        cmp     %i1,%l6
        bgu     DO_GC
 
# code for graph rewrite  ((((S' c) f) g) x) -> (c (f x)) (g x) 
        ld      [%i3+4],%o1             ! ip = c
        add     %i1,-0x10,%l0           ! put c/temp1 in temp0
        st      %o1,[%i1+-0x18]
        st      %l0,[%i1+-0x14]
       ! implicit pop_spine(1) for reference of me, parent, grandparent 
	ld      [%i5+0x4],%i3           ! Use_Me
	ld      [%i5+0x8],%i4           ! Use_Parent
        ld      [%i5+0xC],%l4           ! Use_Grandparent
        ld      [%i3+4],%l0             ! fetch f into %l0
        ld      [%l4+4],%l1             ! fetch x into %l1
	add	%i1,-0x18,%l2		! compute address of temp0 
	std	%l0,[%i1+-0x10]		! store (f x) into temp1
        ld      [%i4+4],%l0             ! fetch g into %l0
	add	%i1,-0x8,%l3		! compute address of temp2
	std	%l0,[%i1+-0x8]		! store (g x) into temp2
	std	%l2,[%l4]		! store temp0/temp2 in root node
	st	%l2,[%i5+0x8]		! top(temp0)
        b       THREAD
        add     %i5,0x8,%i5             ! pop_spine(2)

# _________________________________________________________________
 
DO_CPRIME:
# NEWNODE2
        add     %i1,0x10,%i1
        cmp     %i1,%l6    
        bgu     DO_GC 
 
# code for graph rewrite  ((((C' c) f) g) x) ->  ((c (f x)) g)
        ld      [%i3+4],%o1             ! ip = c
        add     %i1,-0x8,%l0            ! put c/temp1 in temp0
        st      %o1,[%i1+-0x10]
        st      %l0,[%i1+-0xC]
       ! implicit pop_spine(1) for reference of me, parent, grandparent
        ld      [%i5+0x4],%i3           ! Use_Me
        ld      [%i5+0x8],%i4           ! Use_Parent
        ld      [%i5+0xC],%l4           ! Use_Grandparent
        ld      [%i3+4],%l0             ! fetch f into %l0
        ld      [%l4+4],%l1             ! fetch x into %l1
        add     %i1,-0x10,%l2           ! compute address of temp0
        ld      [%i4+4],%l3             ! fetch g into %l3
        std     %l0,[%i1+-0x8]          ! store (f x) into temp1
        std     %l2,[%l4]               ! store temp0/g in root node
        st      %l2,[%i5+0x8]           ! top(temp0)
        b       THREAD
        add     %i5,0x8,%i5             ! pop_spine(2)
 
# _________________________________________________________________
 
DO_BSTAR:
# NEWNODE2
        add     %i1,0x10,%i1
        cmp     %i1,%l6    
        bgu     DO_GC     
 
# code for graph rewrite  ((((B* c) f) g) x) ->  ((c (f x)) g)
        ld      [%i3+4],%o1             ! ip = c
       ! implicit pop_spine(1) for reference of me, parent, grandparent
        ld      [%i5+0x4],%i3           ! Use_Me 
        ld      [%i5+0x8],%i4           ! Use_Parent 
        ld      [%i5+0xC],%l4           ! Use_Grandparent 
        ld      [%l4+4],%l1             ! fetch x into %l1 
        add     %i1,-0x10,%l0           ! put c/temp1 in root node
        st      %o1,[%l4]
        st      %l0,[%l4+4]
        ld      [%i4+4],%l0             ! fetch g into %l0 
        add     %i1,-0x8,%l3            ! compute address of temp0
        ld      [%i3+4],%l2             ! fetch f into %l2
        std     %l0,[%i1+-0x8]          ! store (g x) into temp0
        std     %l2,[%i1+-0x10]         ! store f/temp0 into temp1 
        b       THREAD 
        add     %i5,0xC,%i5             ! pop_spine(3)

# _________________________________________________________________

DO_IF:
# 		   (((IF f) g) h) ->   (I g) | (I h)  
	call	MY_EVAL
	ld	[%i3+4],%o1		! eval(Rme)
#	---

	ld	[%i5+0x8],%l4		! Use_Grandparent
	sethi	%hi(_do_i_value),%l2	! get do_i_value in l1
	tst	%i2
	be	L108
	ld	[%l2+%lo(_do_i_value)],%l1
#	---

# result is true, use g
	ld	[%i5+0x4],%i4		! Use_Parent
	st	%l1,[%l4]		! Lgrandparent = DO_I	
	ld	[%i4+4],%o1		! ip = Rparent
	add	%i5,0xc,%i5		! Pop_Spine(3)
	b	THREAD
	st	%o1,[%l4+4]		! Rgrandparent = Rme

# result is false, use h
L108:
	ld	[%l4+4],%o1		! ip = Rgrandparent
	st	%l1,[%l4]		! Lgrandparent = DO_I	
	b	THREAD
	add	%i5,0xc,%i5		! Pop_Spine(3)

# _________________________________________________________________

DO_LIT:
	ld	[%i5+4],%o7		! recover return address
	ld	[%i3+4],%i2		! result = Rme

	jmpl	%o7+0x8,%g0
	add	%i5,0x8,%i5		! Pop_Spine(1) + return address

# _________________________________________________________________

L111:
	mov	0x1,%l0
	st	%l0,[%fp+-0x4]
	b	L91
	nop
L112:
	st	%g0,[%fp+-0x4]
	b	L91
	nop
L113:
	set	-0x200f1,%l1
	st	%l1,[%fp+-0x4]
	b	L91
	nop
L114:
	.seg	"data1"
L116:
	.ascii	"\012\0"
	.seg	"text"
	set	L116,%o0
	call	_printf,1
	nop
	st	%g0,[%fp+-0x4]
	b	L91
	nop

# _________________________________________________________________
 
DO_NOT:
        call    MY_EVAL
        ld      [%i3+4],%o1             ! eval(Rme)
#       ---
 
        tst     %i2
        bne     L117
	add	%g0,0x0,%i2
#       ---
 
	add	%g0,0x1,%i2
L117:
        sethi   %hi(_do_lit_value),%o0
        ld      [%o0+%lo(_do_lit_value)],%o0
 
        ld      [%i5],%i3               ! Use_Me
        ld      [%i5+4],%o7             ! recover return address
 
        st      %o0,[%i3]               ! Lme = DO_LIT
        st      %i2,[%i3+4]             ! Rme = result
 
        jmpl    %o7+0x8,%g0
        add     %i5,0x8,%i5             ! Pop_Spine(1) + return addr
 
# _________________________________________________________________

DO_ABS:
	call	MY_EVAL
	ld	[%i3+4],%o1		! eval(Rme)
#	---

	tst	%i2
	bge	L119
	ld	[%i5],%i3		! Use_Me
#	---

	sub	%g0,%i2,%i2
L119:
	sethi	%hi(_do_lit_value),%o0
	ld	[%o0+%lo(_do_lit_value)],%o0

	ld	[%i5+4],%o7		! recover return address

	st	%o0,[%i3]		! Lme = DO_LIT
	st	%i2,[%i3+4]		! Rme = result	

	jmpl	%o7+0x8,%g0
	add	%i5,0x8,%i5		! Pop_Spine(1) + return addr

# _________________________________________________________________

L120:
	ld	[%i5],%i3
	add	%sp,LP83,%o3
	st	%o3,[%sp+0x40]
	add	%sp,LP83+0x4,%o0
	mov	%i3,%o4
	ld	[%o4],%o5
	st	%o5,[%o0+0]
	mov	%i5,%o1
	call	_Evaluate,2
	nop
	unimp	4&0xfff
	sub	%fp,0x4,%l0
	ld	[%o0],%l1
	st	%l1,[%l0+0]
	ld	[%i5],%i3
	sub	%fp,0x4,%l3
	mov	%i3,%l4
	ld	[%l3],%l5
	st	%l5,[%l4+0]
	sethi	%hi(_do_lit_value),%o0
	ld	[%o0+%lo(_do_lit_value)],%o0
	st	%o0,[%i3+-0x4]
	sethi	%hi(_count_double),%o1
	ld	[%o1+%lo(_count_double)],%o1
	add	%o1,0x1,%o1
	sethi	%hi(_count_double),%o2
	st	%o1,[%o2+%lo(_count_double)]
	add	%i5,0x4,%i5
	.seg	"data1"
L121:
	.ascii	" %d\0"
	.seg	"text"
	set	L121,%o0
	ld	[%fp+-0x4],%o1
	call	_printf,2
	nop
	b	L91
	nop

# _________________________________________________________________

DO_PLUS:
	call	MY_EVAL			! eval(Rme)
	ld	[%i3+4],%o1
#       ---

	st	%i2,[%i5+-0x4]		! push first param
	sub	%i5,4,%i5

	ld	[%i5+0x8],%i4		! eval(Rparent)
	call	MY_EVAL
	ld	[%i4+4],%o1
#       ---

	ld	[%i5],%l7		! recover earlier result
	ld	[%i5+0x8],%i4		! Use_Parent
	add	%i2,%l7,%i2		! add results

	sethi	%hi(_do_lit_value),%l0
	ld	[%l0+%lo(_do_lit_value)],%l0

	ld	[%i5+0xc],%o7		! recover return address

	st	%l0,[%i4]		! Lparent = DO_I
	st	%i2,[%i4+4]		! Rparent = result

	jmpl	%o7+0x8,%g0
	add	%i5,0x10,%i5		! Pop_Spine(2) + savearea + ret

# _________________________________________________________________

DO_MINUS:
	call	MY_EVAL			! eval(Rme)
	ld	[%i3+4],%o1
#       ---

	st	%i2,[%i5+-0x4]		! push first param
	sub	%i5,4,%i5

	ld	[%i5+0x8],%i4		! eval(Rparent)
	call	MY_EVAL
	ld	[%i4+4],%o1
#       ---

	ld	[%i5],%l7		! recover earlier result
	ld	[%i5+0x8],%i4		! Use_Parent
	sub	%l7,%i2,%i2		! subtract results

	sethi	%hi(_do_lit_value),%l0
	ld	[%l0+%lo(_do_lit_value)],%l0

	ld	[%i5+0xc],%o7		! recover return address

	st	%l0,[%i4]		! Lparent = DO_I
	st	%i2,[%i4+4]		! Rparent = result

	jmpl	%o7+0x8,%g0
	add	%i5,0x10,%i5		! Pop_Spine(2) + savearea + ret

# _________________________________________________________________

DO_ZERO:
	ld	[%i5],%o7		! recover return address
	add	%g0,0x0,%i2		! result = 0

	jmpl	%o7+0x8,%g0
	add	%i5,0x4,%i5

# _________________________________________________________________

DO_ONE:
	ld	[%i5],%o7		! recover return address
	add	%g0,0x1,%i2		! result = 1

	jmpl	%o7+0x8,%g0
	add	%i5,0x4,%i5

# _________________________________________________________________

DO_TWO:
	ld	[%i5],%o7		! recover return address
	add	%g0,0x2,%i2		! result = 2

	jmpl	%o7+0x8,%g0
	add	%i5,0x4,%i5

# _________________________________________________________________

DO_THREE:
	ld	[%i5],%o7		! recover return address
	add	%g0,0x3,%i2		! result = 3

	jmpl	%o7+0x8,%g0
	add	%i5,0x4,%i5

# _________________________________________________________________

L127:
	ld	[%i5],%i3
	add	%sp,LP83,%l6
	st	%l6,[%sp+0x40]
	add	%sp,LP83+0x4,%o0
	mov	%i3,%o1
	ld	[%o1],%o2
	st	%o2,[%o0+0]
	mov	%i5,%o1
	call	_Evaluate,2
	nop
	unimp	4&0xfff
	sub	%fp,0x4,%o4
	ld	[%o0],%o5
	st	%o5,[%o4+0]
	ld	[%i5+0x4],%i4
	add	%sp,LP83,%l0
	st	%l0,[%sp+0x40]
	add	%sp,LP83+0x4,%o0
	mov	%i4,%l1
	ld	[%l1],%l2
	st	%l2,[%o0+0]
	mov	%i5,%o1
	call	_Evaluate,2
	nop
	unimp	4&0xfff
	sub	%fp,0x8,%l4
	ld	[%o0],%l5
	st	%l5,[%l4+0]
	ld	[%i5+0x4],%i4
	ld	[%fp+-0x4],%o0
	ld	[%fp+-0x8],%o1
	call	.mul,2
	nop
	st	%o0,[%fp+-0x4]
	sub	%fp,0x4,%o0
	mov	%i4,%o1
	ld	[%o0],%o2
	st	%o2,[%o1+0]
	sethi	%hi(_do_lit_value),%o4
	ld	[%o4+%lo(_do_lit_value)],%o4
	st	%o4,[%i4+-0x4]
	sethi	%hi(_count_double),%o5
	ld	[%o5+%lo(_count_double)],%o5
	add	%o5,0x1,%o5
	sethi	%hi(_count_double),%o7
	st	%o5,[%o7+%lo(_count_double)]
	add	%i5,0x8,%i5
	b	L91
	nop
L128:
	ld	[%i5],%i3
	add	%sp,LP83,%l0
	st	%l0,[%sp+0x40]
	add	%sp,LP83+0x4,%o0
	mov	%i3,%l1
	ld	[%l1],%l2
	st	%l2,[%o0+0]
	mov	%i5,%o1
	call	_Evaluate,2
	nop
	unimp	4&0xfff
	sub	%fp,0x4,%l4
	ld	[%o0],%l5
	st	%l5,[%l4+0]
	ld	[%i5+0x4],%i4
	add	%sp,LP83,%o0
	st	%o0,[%sp+0x40]
	add	%sp,LP83+0x4,%o0
	mov	%i4,%o1
	ld	[%o1],%o2
	st	%o2,[%o0+0]
	mov	%i5,%o1
	call	_Evaluate,2
	nop
	unimp	4&0xfff
	sub	%fp,0x8,%o4
	ld	[%o0],%o5
	st	%o5,[%o4+0]
	ld	[%i5+0x4],%i4
	ld	[%fp+-0x4],%o0
	ld	[%fp+-0x8],%o1
	call	.rem,2
	nop
	st	%o0,[%fp+-0x4]
	sub	%fp,0x4,%l0
	mov	%i4,%l1
	ld	[%l0],%l2
	st	%l2,[%l1+0]
	sethi	%hi(_do_lit_value),%l4
	ld	[%l4+%lo(_do_lit_value)],%l4
	st	%l4,[%i4+-0x4]
	sethi	%hi(_count_double),%l5
	ld	[%l5+%lo(_count_double)],%l5
	add	%l5,0x1,%l5
	sethi	%hi(_count_double),%l6
	st	%l5,[%l6+%lo(_count_double)]
	add	%i5,0x8,%i5
	b	L91
	nop
L129:
	ld	[%i5],%i3
	add	%sp,LP83,%o0
	st	%o0,[%sp+0x40]
	add	%sp,LP83+0x4,%o0
	mov	%i3,%o1
	ld	[%o1],%o2
	st	%o2,[%o0+0]
	mov	%i5,%o1
	call	_Evaluate,2
	nop
	unimp	4&0xfff
	sub	%fp,0x4,%o4
	ld	[%o0],%o5
	st	%o5,[%o4+0]
	ld	[%i5+0x4],%i4
	add	%sp,LP83,%l0
	st	%l0,[%sp+0x40]
	add	%sp,LP83+0x4,%o0
	mov	%i4,%l1
	ld	[%l1],%l2
	st	%l2,[%o0+0]
	mov	%i5,%o1
	call	_Evaluate,2
	nop
	unimp	4&0xfff
	sub	%fp,0x8,%l4
	ld	[%o0],%l5
	st	%l5,[%l4+0]
	ld	[%i5+0x4],%i4
	ld	[%fp+-0x4],%o0
	ld	[%fp+-0x8],%o1
	call	.div,2
	nop
	st	%o0,[%fp+-0x4]
	sub	%fp,0x4,%o0
	mov	%i4,%o1
	ld	[%o0],%o2
	st	%o2,[%o1+0]
	sethi	%hi(_do_lit_value),%o4
	ld	[%o4+%lo(_do_lit_value)],%o4
	st	%o4,[%i4+-0x4]
	sethi	%hi(_count_double),%o5
	ld	[%o5+%lo(_count_double)],%o5
	add	%o5,0x1,%o5
	sethi	%hi(_count_double),%o7
	st	%o5,[%o7+%lo(_count_double)]
	add	%i5,0x8,%i5
	b	L91
	nop
L130:
	ld	[%i5],%i3
	add	%sp,LP83,%l0
	st	%l0,[%sp+0x40]
	add	%sp,LP83+0x4,%o0
	mov	%i3,%l1
	ld	[%l1],%l2
	st	%l2,[%o0+0]
	mov	%i5,%o1
	call	_Evaluate,2
	nop
	unimp	4&0xfff
	sub	%fp,0x4,%l4
	ld	[%o0],%l5
	st	%l5,[%l4+0]
	ld	[%i5+0x4],%i4
	add	%sp,LP83,%o0
	st	%o0,[%sp+0x40]
	add	%sp,LP83+0x4,%o0
	mov	%i4,%o1
	ld	[%o1],%o2
	st	%o2,[%o0+0]
	mov	%i5,%o1
	call	_Evaluate,2
	nop
	unimp	4&0xfff
	sub	%fp,0x8,%o4
	ld	[%o0],%o5
	st	%o5,[%o4+0]
	ld	[%i5+0x4],%i4
	ld	[%fp+-0x4],%l0
	ld	[%fp+-0x8],%l1
	xorcc	%l0,%l1,%g0
	bge	L131
	nop
	ld	[%fp+-0x4],%o0
	ld	[%fp+-0x8],%o1
	call	.rem,2
	nop
	tst	%o0
	be	L131
	nop
	ld	[%fp+-0x4],%o0
	ld	[%fp+-0x8],%o1
	call	.div,2
	nop
	st	%o0,[%fp+-0x4]
	ld	[%fp+-0x4],%o0
	sub	%o0,0x1,%o0
	st	%o0,[%fp+-0x4]
	b	L132
	nop
L131:
	ld	[%fp+-0x4],%o0
	ld	[%fp+-0x8],%o1
	call	.div,2
	nop
	st	%o0,[%fp+-0x4]
L132:
	sub	%fp,0x4,%o0
	mov	%i4,%o1
	ld	[%o0],%o2
	st	%o2,[%o1+0]
	sethi	%hi(_do_lit_value),%o4
	ld	[%o4+%lo(_do_lit_value)],%o4
	st	%o4,[%i4+-0x4]
	sethi	%hi(_count_double),%o5
	ld	[%o5+%lo(_count_double)],%o5
	add	%o5,0x1,%o5
	sethi	%hi(_count_double),%o7
	st	%o5,[%o7+%lo(_count_double)]
	add	%i5,0x8,%i5
	b	L91
	nop

# _________________________________________________________________

DO_LESS:
	call	MY_EVAL			! eval(Rme)
	ld	[%i3+4],%o1
#       ---

	st	%i2,[%i5+-0x4]		! push first param
	sub	%i5,4,%i5

	ld	[%i5+0x8],%i4		! eval(Rparent)
	call	MY_EVAL
	ld	[%i4+4],%o1
#       ---

	ld	[%i5],%l7		! recover earlier result

	ld	[%i5+0x8],%i4		! Use_Parent
	cmp	%l7,%i2
	bge	L2000002
	add	%g0,0,%i2		! result = 0

	add	%g0,1,%i2		! result = 1
L2000002:
	sethi	%hi(_do_lit_value),%l0
	ld	[%l0+%lo(_do_lit_value)],%l0

	ld	[%i5+0xC],%o7		! recover return addr

	st	%l0,[%i4]		! Lparent = DO_LIT
	st	%i2,[%i4+4]		! Rparent = result

	jmpl	%o7+0x8,%g0
	add	%i5,0x10,%i5		! Pop_Spine(2) + savearea + ret

# _________________________________________________________________

L134:
	ld	[%i5],%i3
	add	%sp,LP83,%o3
	st	%o3,[%sp+0x40]
	add	%sp,LP83+0x4,%o0
	mov	%i3,%o4
	ld	[%o4],%o5
	st	%o5,[%o0+0]
	mov	%i5,%o1
	call	_Evaluate,2
	nop
	unimp	4&0xfff
	sub	%fp,0x4,%l0
	ld	[%o0],%l1
	st	%l1,[%l0+0]
	ld	[%i5+0x4],%i4
	add	%sp,LP83,%l3
	st	%l3,[%sp+0x40]
	add	%sp,LP83+0x4,%o0
	mov	%i4,%l4
	ld	[%l4],%l5
	st	%l5,[%o0+0]
	mov	%i5,%o1
	call	_Evaluate,2
	nop
	unimp	4&0xfff
	sub	%fp,0x8,%o1
	ld	[%o0],%o2
	st	%o2,[%o1+0]
	ld	[%i5+0x4],%i4
	ld	[%fp+-0x4],%o4
	ld	[%fp+-0x8],%o5
	cmp	%o4,%o5
	ble	L2000004
	nop
	mov	1,%o7
	b	L2000005
	nop
L2000004:
	mov	0,%o7
L2000005:
	st	%o7,[%fp+-0x4]
	sub	%fp,0x4,%l0
	mov	%i4,%l1
	ld	[%l0],%l2
	st	%l2,[%l1+0]
	sethi	%hi(_do_lit_value),%l4
	ld	[%l4+%lo(_do_lit_value)],%l4
	st	%l4,[%i4+-0x4]
	sethi	%hi(_count_double),%l5
	ld	[%l5+%lo(_count_double)],%l5
	add	%l5,0x1,%l5
	sethi	%hi(_count_double),%l6
	st	%l5,[%l6+%lo(_count_double)]
	add	%i5,0x8,%i5
	b	L91
	nop
L135:
	ld	[%i5],%i3
	add	%sp,LP83,%o0
	st	%o0,[%sp+0x40]
	add	%sp,LP83+0x4,%o0
	mov	%i3,%o1
	ld	[%o1],%o2
	st	%o2,[%o0+0]
	mov	%i5,%o1
	call	_Evaluate,2
	nop
	unimp	4&0xfff
	sub	%fp,0x4,%o4
	ld	[%o0],%o5
	st	%o5,[%o4+0]
	ld	[%i5+0x4],%i4
	add	%sp,LP83,%l0
	st	%l0,[%sp+0x40]
	add	%sp,LP83+0x4,%o0
	mov	%i4,%l1
	ld	[%l1],%l2
	st	%l2,[%o0+0]
	mov	%i5,%o1
	call	_Evaluate,2
	nop
	unimp	4&0xfff
	sub	%fp,0x8,%l4
	ld	[%o0],%l5
	st	%l5,[%l4+0]
	ld	[%i5+0x4],%i4
	ld	[%fp+-0x4],%o0
	ld	[%fp+-0x8],%o1
	cmp	%o0,%o1
	bne	L2000006
	nop
	mov	1,%o2
	b	L2000007
	nop
L2000006:
	mov	0,%o2
L2000007:
	st	%o2,[%fp+-0x4]
	sub	%fp,0x4,%o3
	mov	%i4,%o4
	ld	[%o3],%o5
	st	%o5,[%o4+0]
	sethi	%hi(_do_lit_value),%l0
	ld	[%l0+%lo(_do_lit_value)],%l0
	st	%l0,[%i4+-0x4]
	sethi	%hi(_count_double),%l1
	ld	[%l1+%lo(_count_double)],%l1
	add	%l1,0x1,%l1
	sethi	%hi(_count_double),%l2
	st	%l1,[%l2+%lo(_count_double)]
	add	%i5,0x8,%i5
	b	L91
	nop
L136:
	ld	[%i5],%i3
	add	%sp,LP83,%l3
	st	%l3,[%sp+0x40]
	add	%sp,LP83+0x4,%o0
	mov	%i3,%l4
	ld	[%l4],%l5
	st	%l5,[%o0+0]
	mov	%i5,%o1
	call	_Evaluate,2
	nop
	unimp	4&0xfff
	sub	%fp,0x4,%o1
	ld	[%o0],%o2
	st	%o2,[%o1+0]
	ld	[%fp+-0x4],%o4
	tst	%o4
	be	L137
	nop
	ld	[%i5+0x4],%i4
	add	%sp,LP83,%o0
	st	%o0,[%sp+0x40]
	add	%sp,LP83+0x4,%o0
	mov	%i4,%o1
	ld	[%o1],%o2
	st	%o2,[%o0+0]
	mov	%i5,%o1
	call	_Evaluate,2
	nop
	unimp	4&0xfff
	sub	%fp,0x8,%o4
	ld	[%o0],%o5
	st	%o5,[%o4+0]
	ld	[%fp+-0x8],%l0
	tst	%l0
	be	L138
	nop
	mov	0x1,%l1
	st	%l1,[%fp+-0x4]
	b	L139
	nop
L138:
	st	%g0,[%fp+-0x4]
L139:
	b	L140
	nop
L137:
	st	%g0,[%fp+-0x4]
L140:
	ld	[%i5+0x4],%i4
	sub	%fp,0x4,%l2
	mov	%i4,%l3
	ld	[%l2],%l4
	st	%l4,[%l3+0]
	sethi	%hi(_do_lit_value),%l6
	ld	[%l6+%lo(_do_lit_value)],%l6
	st	%l6,[%i4+-0x4]
	sethi	%hi(_count_double),%o0
	ld	[%o0+%lo(_count_double)],%o0
	add	%o0,0x1,%o0
	sethi	%hi(_count_double),%o1
	st	%o0,[%o1+%lo(_count_double)]
	add	%i5,0x8,%i5
	b	L91
	nop
L141:
	ld	[%i5],%i3
	add	%sp,LP83,%o2
	st	%o2,[%sp+0x40]
	add	%sp,LP83+0x4,%o0
	mov	%i3,%o3
	ld	[%o3],%o4
	st	%o4,[%o0+0]
	mov	%i5,%o1
	call	_Evaluate,2
	nop
	unimp	4&0xfff
	sub	%fp,0x4,%o7
	ld	[%o0],%l0
	st	%l0,[%o7+0]
	ld	[%fp+-0x4],%l2
	tst	%l2
	bne	L142
	nop
	ld	[%i5+0x4],%i4
	add	%sp,LP83,%o0
	st	%o0,[%sp+0x40]
	add	%sp,LP83+0x4,%o0
	mov	%i4,%o1
	ld	[%o1],%o2
	st	%o2,[%o0+0]
	mov	%i5,%o1
	call	_Evaluate,2
	nop
	unimp	4&0xfff
	sub	%fp,0x8,%o4
	ld	[%o0],%o5
	st	%o5,[%o4+0]
	ld	[%fp+-0x8],%l0
	tst	%l0
	bne	L143
	nop
	st	%g0,[%fp+-0x4]
	b	L144
	nop
L143:
	mov	0x1,%l1
	st	%l1,[%fp+-0x4]
L144:
	b	L145
	nop
L142:
	mov	0x1,%l2
	st	%l2,[%fp+-0x4]
L145:
	ld	[%i5+0x4],%i4
	sub	%fp,0x4,%l3
	mov	%i4,%l4
	ld	[%l3],%l5
	st	%l5,[%l4+0]
	sethi	%hi(_do_lit_value),%o0
	ld	[%o0+%lo(_do_lit_value)],%o0
	st	%o0,[%i4+-0x4]
	sethi	%hi(_count_double),%o1
	ld	[%o1+%lo(_count_double)],%o1
	add	%o1,0x1,%o1
	sethi	%hi(_count_double),%o2
	st	%o1,[%o2+%lo(_count_double)]
	add	%i5,0x8,%i5
	b	L91
	nop
L146:
	ld	[%i5+0x4],%i4
	ld	[%i5],%i3
	sub	%i4,0x4,%o3
	st	%o3,[%fp+-0x4]
	sub	%i3,0x4,%o4
	st	%o4,[%i4+-0x4]
	add	%i5,0x8,%i5
	b	L91
	nop
L147:
	ld	[%i5+0x4],%i4
	add	%sp,LP83,%o5
	st	%o5,[%sp+0x40]
	add	%sp,LP83+0x4,%o0
	mov	%i4,%o7
	ld	[%o7],%l0
	st	%l0,[%o0+0]
	mov	%i5,%o1
	call	_Evaluate,2
	nop
	unimp	4&0xfff
	sub	%fp,0x4,%l2
	ld	[%o0],%l3
	st	%l3,[%l2+0]
	sethi	%hi(_next_free_node),%l5
	ld	[%l5+%lo(_next_free_node)],%i2
	add	%i2,0x8,%l6
	sethi	%hi(_next_free_node),%o0
	st	%l6,[%o0+%lo(_next_free_node)]
	sethi	%hi(_heap_end),%o1
	ld	[%o1+%lo(_heap_end)],%o1
	cmp	%i2,%o1
	blu	L148
	nop
	mov	%i5,%o0
	call	_newnode_continue,1
	nop
	mov	%o0,%i2
L148:
	ld	[%fp+-0x4],%i1
	ld	[%i5+0x4],%i4
	ld	[%i5],%i3
	st	%i2,[%i4+-0x4]
	add	%i1,0x4,%o2
	mov	%i4,%o3
	ld	[%o2],%o4
	st	%o4,[%o3+0]
	sethi	%hi(_count_double),%o7
	ld	[%o7+%lo(_count_double)],%o7
	add	%o7,0x1,%o7
	sethi	%hi(_count_double),%l0
	st	%o7,[%l0+%lo(_count_double)]
	sethi	%hi(_count_double),%l1
	ld	[%l1+%lo(_count_double)],%l1
	add	%l1,0x1,%l1
	sethi	%hi(_count_double),%l2
	st	%l1,[%l2+%lo(_count_double)]
	sub	%fp,0xc,%l3
	mov	%i3,%l4
	ld	[%l4],%l5
	st	%l5,[%l3+0]
	mov	%i2,%o0
	ld	[%l3],%o1
	st	%o1,[%o0+0]
	add	%i2,0x4,%o3
	ld	[%i1],%o4
	add	%o4,0x4,%o5
	ld	[%o5],%o7
	st	%o7,[%o3+0]
	sethi	%hi(_count_double),%l1
	ld	[%l1+%lo(_count_double)],%l1
	add	%l1,0x1,%l1
	sethi	%hi(_count_double),%l2
	st	%l1,[%l2+%lo(_count_double)]
	add	%i2,0x4,%l3
	st	%l3,[%i5]
	b	L86
	nop
L149:
	.seg	"data1"
L150:
	.ascii	"\012\012 spine stack underflow\012\0"
	.seg	"text"
	set	L150,%o0
	call	_printf,1
	nop
	mov	-0x1,%o0
	call	_exit,1
	nop
L151:
	ld	[%i5],%i3
	add	%sp,LP83,%l4
	st	%l4,[%sp+0x40]
	add	%sp,LP83+0x4,%o0
	mov	%i3,%l5
	ld	[%l5],%l6
	st	%l6,[%o0+0]
	mov	%i5,%o1
	call	_Evaluate,2
	nop
	unimp	4&0xfff
	sub	%fp,0x4,%o2
	ld	[%o0],%o3
	st	%o3,[%o2+0]
	ld	[%fp+-0x4],%o5
	cmp	%o5,0x3
	bge	L152
	nop
	mov	0x1,%o0
	st	%o0,[%fp+-0x4]
	add	%i5,0x4,%i5
	b	L91
	nop
L152:
	sethi	%hi(_next_free_node),%o1
	ld	[%o1+%lo(_next_free_node)],%i2
	add	%i2,0x30,%o2
	sethi	%hi(_next_free_node),%o3
	st	%o2,[%o3+%lo(_next_free_node)]
	sethi	%hi(_next_free_node),%o4
	ld	[%o4+%lo(_next_free_node)],%o4
	sethi	%hi(_heap_end),%o5
	ld	[%o5+%lo(_heap_end)],%o5
	cmp	%o4,%o5
	blu	L153
	nop
	mov	%i5,%o0
	call	_collect_garbage,1
	nop
	sethi	%hi(_next_free_node),%o0
	ld	[%o0+%lo(_next_free_node)],%i2
	add	%i2,0x30,%o1
	sethi	%hi(_next_free_node),%o2
	st	%o1,[%o2+%lo(_next_free_node)]
	sethi	%hi(_next_free_node),%o3
	ld	[%o3+%lo(_next_free_node)],%o3
	sethi	%hi(_heap_end),%o4
	ld	[%o4+%lo(_heap_end)],%o4
	cmp	%o3,%o4
	blu	L154
	nop
	.seg	"data1"
L155:
	.ascii	"Out of heap!\0"
	.seg	"text"
	set	L155,%o0
	call	_printf,1
	nop
	mov	-0x1,%o0
	call	_exit,1
	nop
L154:
L153:
	ld	[%i5],%i3
	sub	%fp,0x8,%o0
	mov	%i3,%o1
	ld	[%o1],%o2
	st	%o2,[%o0+0]
	mov	0x21,%o4
	st	%o4,[%i2]
	ld	[%fp+-0x4],%o5
	sub	%o5,0x1,%o7
	st	%o7,[%i2+0x4]
	sethi	%hi(_count_double),%l0
	ld	[%l0+%lo(_count_double)],%l0
	add	%l0,0x1,%l0
	sethi	%hi(_count_double),%l1
	st	%l0,[%l1+%lo(_count_double)]
	mov	0x99,%l2
	st	%l2,[%i2+0x8]
	st	%i2,[%i2+0xc]
	sethi	%hi(_count_double),%l3
	ld	[%l3+%lo(_count_double)],%l3
	add	%l3,0x1,%l3
	sethi	%hi(_count_double),%l4
	st	%l3,[%l4+%lo(_count_double)]
	mov	0x25,%l5
	st	%l5,[%i2+0x10]
	add	%i2,0x8,%l6
	st	%l6,[%i2+0x14]
	sethi	%hi(_count_double),%o0
	ld	[%o0+%lo(_count_double)],%o0
	add	%o0,0x1,%o0
	sethi	%hi(_count_double),%o1
	st	%o0,[%o1+%lo(_count_double)]
	mov	0x21,%o2
	st	%o2,[%i2+0x18]
	ld	[%fp+-0x4],%o3
	sub	%o3,0x2,%o4
	st	%o4,[%i2+0x1c]
	sethi	%hi(_count_double),%o5
	ld	[%o5+%lo(_count_double)],%o5
	add	%o5,0x1,%o5
	sethi	%hi(_count_double),%o7
	st	%o5,[%o7+%lo(_count_double)]
	mov	0x99,%l0
	st	%l0,[%i2+0x20]
	add	%i2,0x18,%l1
	st	%l1,[%i2+0x24]
	sethi	%hi(_count_double),%l2
	ld	[%l2+%lo(_count_double)],%l2
	add	%l2,0x1,%l2
	sethi	%hi(_count_double),%l3
	st	%l2,[%l3+%lo(_count_double)]
	add	%i2,0x10,%l4
	st	%l4,[%i2+0x28]
	add	%i2,0x20,%l5
	st	%l5,[%i2+0x2c]
	sethi	%hi(_count_double),%l6
	ld	[%l6+%lo(_count_double)],%l6
	add	%l6,0x1,%l6
	sethi	%hi(_count_double),%o0
	st	%l6,[%o0+%lo(_count_double)]
	mov	0x5,%o1
	st	%o1,[%fp+-0xc]
	st	%o1,[%i3+-0x4]
	add	%i2,0x28,%o2
	st	%o2,[%i3]
	sethi	%hi(_count_double),%o3
	ld	[%o3+%lo(_count_double)],%o3
	add	%o3,0x1,%o3
	sethi	%hi(_count_double),%o4
	st	%o3,[%o4+%lo(_count_double)]
	b	L86
	nop
L156:
	ld	[%i5],%i3
	add	%sp,LP83,%o5
	st	%o5,[%sp+0x40]
	add	%sp,LP83+0x4,%o0
	mov	%i3,%o7
	ld	[%o7],%l0
	st	%l0,[%o0+0]
	mov	%i5,%o1
	call	_Evaluate,2
	nop
	unimp	4&0xfff
	sub	%fp,0x4,%l2
	ld	[%o0],%l3
	st	%l3,[%l2+0]
	ld	[%fp+-0x4],%l5
	cmp	%l5,0x2
	bge	L157
	nop
	mov	0x1,%o0
	st	%o0,[%fp+-0x4]
	add	%i5,0x4,%i5
	b	L91
	nop
L157:
	sethi	%hi(_next_free_node),%o1
	ld	[%o1+%lo(_next_free_node)],%i2
	add	%i2,0x40,%o2
	sethi	%hi(_next_free_node),%o3
	st	%o2,[%o3+%lo(_next_free_node)]
	sethi	%hi(_next_free_node),%o4
	ld	[%o4+%lo(_next_free_node)],%o4
	sethi	%hi(_heap_end),%o5
	ld	[%o5+%lo(_heap_end)],%o5
	cmp	%o4,%o5
	blu	L158
	nop
	mov	%i5,%o0
	call	_collect_garbage,1
	nop
	sethi	%hi(_next_free_node),%o0
	ld	[%o0+%lo(_next_free_node)],%i2
	add	%i2,0x40,%o1
	sethi	%hi(_next_free_node),%o2
	st	%o1,[%o2+%lo(_next_free_node)]
	sethi	%hi(_next_free_node),%o3
	ld	[%o3+%lo(_next_free_node)],%o3
	sethi	%hi(_heap_end),%o4
	ld	[%o4+%lo(_heap_end)],%o4
	cmp	%o3,%o4
	blu	L159
	nop
	.seg	"data1"
L160:
	.ascii	"Out of heap!\0"
	.seg	"text"
	set	L160,%o0
	call	_printf,1
	nop
	mov	-0x1,%o0
	call	_exit,1
	nop
L159:
L158:
	ld	[%i5],%i3
	sub	%fp,0x8,%o0
	mov	%i3,%o1
	ld	[%o1],%o2
	st	%o2,[%o0+0]
	mov	0x21,%o4
	st	%o4,[%i2]
	ld	[%fp+-0x4],%o5
	sub	%o5,0x1,%o7
	st	%o7,[%i2+0x4]
	sethi	%hi(_count_double),%l0
	ld	[%l0+%lo(_count_double)],%l0
	add	%l0,0x1,%l0
	sethi	%hi(_count_double),%l1
	st	%l0,[%l1+%lo(_count_double)]
	mov	0xa5,%l2
	st	%l2,[%i2+0x8]
	st	%i2,[%i2+0xc]
	sethi	%hi(_count_double),%l3
	ld	[%l3+%lo(_count_double)],%l3
	add	%l3,0x1,%l3
	sethi	%hi(_count_double),%l4
	st	%l3,[%l4+%lo(_count_double)]
	mov	0x25,%l5
	st	%l5,[%i2+0x10]
	add	%i2,0x8,%l6
	st	%l6,[%i2+0x14]
	sethi	%hi(_count_double),%o0
	ld	[%o0+%lo(_count_double)],%o0
	add	%o0,0x1,%o0
	sethi	%hi(_count_double),%o1
	st	%o0,[%o1+%lo(_count_double)]
	mov	0x21,%o2
	st	%o2,[%i2+0x18]
	ld	[%fp+-0x4],%o3
	sub	%o3,0x2,%o4
	st	%o4,[%i2+0x1c]
	sethi	%hi(_count_double),%o5
	ld	[%o5+%lo(_count_double)],%o5
	add	%o5,0x1,%o5
	sethi	%hi(_count_double),%o7
	st	%o5,[%o7+%lo(_count_double)]
	mov	0xa5,%l0
	st	%l0,[%i2+0x20]
	add	%i2,0x18,%l1
	st	%l1,[%i2+0x24]
	sethi	%hi(_count_double),%l2
	ld	[%l2+%lo(_count_double)],%l2
	add	%l2,0x1,%l2
	sethi	%hi(_count_double),%l3
	st	%l2,[%l3+%lo(_count_double)]
	add	%i2,0x10,%l4
	st	%l4,[%i2+0x28]
	add	%i2,0x20,%l5
	st	%l5,[%i2+0x2c]
	sethi	%hi(_count_double),%l6
	ld	[%l6+%lo(_count_double)],%l6
	add	%l6,0x1,%l6
	sethi	%hi(_count_double),%o0
	st	%l6,[%o0+%lo(_count_double)]
	mov	0x25,%o1
	st	%o1,[%i2+0x30]
	mov	0x35,%o2
	st	%o2,[%i2+0x34]
	sethi	%hi(_count_double),%o3
	ld	[%o3+%lo(_count_double)],%o3
	add	%o3,0x1,%o3
	sethi	%hi(_count_double),%o4
	st	%o3,[%o4+%lo(_count_double)]
	add	%i2,0x30,%o5
	st	%o5,[%i2+0x38]
	add	%i2,0x28,%o7
	st	%o7,[%i2+0x3c]
	sethi	%hi(_count_double),%l0
	ld	[%l0+%lo(_count_double)],%l0
	add	%l0,0x1,%l0
	sethi	%hi(_count_double),%l1
	st	%l0,[%l1+%lo(_count_double)]
	mov	0x5,%l2
	st	%l2,[%fp+-0xc]
	st	%l2,[%i3+-0x4]
	add	%i2,0x38,%l3
	st	%l3,[%i3]
	sethi	%hi(_count_double),%l4
	ld	[%l4+%lo(_count_double)],%l4
	add	%l4,0x1,%l4
	sethi	%hi(_count_double),%l5
	st	%l4,[%l5+%lo(_count_double)]
	b	L86
	nop
L161:
L162:
L163:
L164:
L165:
L166:
L167:
L168:
L169:
L170:
L171:
L172:
L173:
L174:
L175:
L176:
L177:
	.seg	"data1"
L178:
	.ascii	"\012\012 jump to bad combinator\012\0"
	.seg	"text"
	set	L178,%o0
	call	_printf,1
	nop
	mov	-0x1,%o0
	call	_exit,1
	nop
	b	L91
	nop

# _________________________________________________________________

# jump table for case statement

	.word	L178
	.word	L178
	L2000008:  
	.word	L178
	.word	DO_I
	.word	DO_K
	.word	DO_S
	.word	DO_SPRIME
	.word	DO_B
	.word	DO_C
	.word	DO_IF
	.word	DO_LIT
	.word	DO_PLUS
	.word	DO_MINUS
	.word	DO_LESS
	.word	L127	! DO_TIMES
	.word	DO_ONE	
	.word	DO_ZERO	
	.word	L135	! DO_EQ
	.word	L134	! DO_GREAT
	.word	L146	! DO_P
	.word	L147	! DO_U
	.word	L177	! UNUSED
	.word	DO_NOT
	.word	DO_ABS
	.word	L111	! DO_TRUE
	.word	L112	! DO_FALSE
	.word	L113	! DO_NIL
	.word	L120	! DO_PRINT
	.word	L114	! DO_NL
	.word	L136	! DO_AND
 	.word	L141	! DO_OR
	.word	L128	! DO_MOD
	.word	DO_BSTAR
	.word	DO_CPRIME
	.word	DO_TWO
	.word	DO_THREE
	.word	L129	! DO_DIV
	.word	L149	! SPINE_UNDERFLOW
	.word	L161	! DO_S1
	.word	L162	! DO_S2
	.word	L151	! DO_S3
	.word	L163	! DO_S4
	.word	L164	! DO_S5
	.word	L156	! DO_S6
	.word	L165	! DO_S7
	.word	L166	! DO_S8
	.word	L130	! DO_FLOOR
	.word	L167
	.word	L168
	.word	L169
	.word	L170
	.word	L171
	.word	L172
	.word	L173
	.word	L174
	.word	L175
	.word	L176
# -- invalid table entries
	.word	L176
	.word	L176
	.word	L176
	.word	L176
	.word	L176
	.word	L176
	.word	L176
	.word	L176
	.word	L176
	.word	L176
	.word	L176
	.word	L176
	.word	L176
	.word	L176
	.word	L176
	.word	L176
	.word	L176
	.word	L176
	.word	L176
	.word	L176
	.word	L176
	.word	L176

L91:
	sub	%fp,0x4,%o0
L85:
LE83:
	mov	4,%o1
	call	.stret4
	nop


       LF83 = -120
	LP83 = 96
	LT83 = 104
	.seg	"data"
	.seg	"text"
	.proc 04
	.global	_mapval
_mapval:
	!#PROLOGUE# 0
	sethi	%hi(LF179),%g1
	add	%g1,%lo(LF179),%g1
	save	%sp,%g1,%sp
	!#PROLOGUE# 1

# return actual address with highest bit set
	sll	%i0,0x2,%i0
	set	L2000008,%l2

	ld	[%i0+%l2],%i0

	or	%i0,1,%i0

	ret
	restore
       LF179 = -72
	LP179 = 64
	LT179 = 64
	.seg	"data"
