#NO_APP

# /* GRAPH REDUCTION TESTING CODE ----- TIGRE */
#  VAX ASSEMBLY LANGUAGE
# /* (C) Copyright 1988   Philip Koopman Jr.  */
# /*  Last update:  3/11/89   */
# /*  Test code version -- not for distribution  */
# /* kernel for reduction engine */
# /*  this version uses the embedded jsr commands in the mark word */

.set MARKED,-1
.set UNMARKED,0x9F160101

.set HEAPSTRIDE,3


.set BREAKCOUNT,38

# Celltype *nodea,*nodeb,*nodec ;
.comm _nodec,4
.comm _nodeb,4
.comm _nodea,4


#  r0 - scratch
#  r1 - result
#  r2 - resultb
#  r3 - temp1
#  r4 - temp2
#  r5 - temp3
#  r6 - 
#  r7 - parent_ptr
#  r8 - me_ptr
#  r9 - ip
# r10 - count
# r11 - next_free_node
# r12 - AP
# r13 - FP
# r14 - SP
# r15 - PC

#     register Valuetype result,resultb ;
#     register Valuetype ip;
#     register Celltype **temp_spine, **parent_spine ;
#     register Celltype *temp1,*temp2;
#     register Celltype *temp3;

# Valuetype Evaluate(Valuetype root)
.globl _Evaluate
#   {
_Evaluate:
	.word 0xff4

#     ip = root ;
	movl 4(ap),r9
	movl _next_free_node,r11
	movl _count,r10

# call kernel subroutine
        incl _spine_stack  # so that GC will call stack cleanup word
	movab -8(sp),_fixup_start   # starting point of stack fixup for GC
	jsb -2(r9)
        decl _spine_stack

	movl r10,_count
	movl r11,_next_free_node
#  move result to return parameter register
	movl r1,r0
# do a procedure return
	ret


L8:	calls $0,_spine_overflow
	ret

#______________________________________________________________________
#  case DO_I:
	.align 2
	.byte 0
DO_I:
	incl r10
#     ip = Rme ;
#     spine_stack -= 1;
	movl *(sp),r9
#  pop_spine_stack(1)
	movab 4(sp),sp
#     continue;
# note:   jmp *(sp)+ doesn't seem to work properly on maxwell
	jmp (r9)

#______________________________________________________________________
#     case DO_K:
	.align 2
	.byte 0
DO_K:
	incl r10
#     ip = Rme
	movl *(sp),r9
#  pop_spine_stack(2)
	movab 8(sp),sp
# THREAD
	jmp (r9)

#______________________________________________________________________
#     case DO_S:
# --> garbage collection entry point
	.align 2
L13:
	pushab _nodeb
	pushab _nodea
	pushab 8(sp)
	calls $3,_newnode2_continue
	movl _nodea,r3
	movl _nodeb,r4
	movl _next_free_node,r11
	jbr L16
#
# ------------> entry point here <------------------
	.align 2
	.byte 0
DO_S:
	incl r10
#	NEWNODE2;
	movl r11,r3
        movab HEAPSTRIDE*4(r11),r4
	movab 2*HEAPSTRIDE*4(r11),r11
        cmpl r3,_heap_end
	jgequ L13

L16:
	movl (r3),r0	# -- Pre-touch heap node to prevent later misses
#     Ltemp1  = ip             = Rme ;
#     Ltemp2                   = Rparent ;
	movl *(sp)+,r9
	movl 4(sp),r7    # r7 now contains parent pointer
	movl *(sp),(r4)
	movl (r7),r0
#     parent_spine -= 1 ;
#     Rtemp1  = Rtemp2  = Rparent ;
	movl r0,4(r4)
	movl r9,(r3)
	movl r0,4(r3)
#     Lparent.child = temp1 ;
	movab -2(r3),-4(r7) # ??? re-pointed to mark field
#     Rparent.child = temp2 ;
	movab -2(r4),(r7)   # ??? re-pointed to mark field

#     *(--temp_spine) = temp1+1 ;
	movab 4(r3),(sp)
#     continue ;
#  ??? write flush not required -- sp update flushed the node
#	movl r0,_nodea  # ?? flush write buffer
	jmp (r9)

#______________________________________________________________________
#     case DO_SPRIME:
# --> garbage collection entry point
	.align 2
L17:
	pushab _nodec
	pushab _nodeb
	pushab _nodea
	pushab 12(sp)
	calls $4,_newnode3_continue
	movl _nodea,r3
	movl _nodeb,r4
	movl _nodec,r5
	movl _next_free_node,r11
	jbr L18
#
# ------------> entry point here <------------------
	.align 2
	.byte 0
DO_SPRIME:
	incl r10

#     NEWNODE3;
	movl r11,r3
        movab HEAPSTRIDE*4(r11),r4
	movab 2*HEAPSTRIDE*4(r11),r5
	movab 3*HEAPSTRIDE*4(r11),r11
        cmpl r3,_heap_end
	jgequ L17

L18:
	movl (r3),r0	# -- Pre-touch heap node to prevent later misses
#     Ltemp1  = ip             = Rme ;
	movl *(sp)+,r9
	movl r9,(r3)
#     Rtemp1.child  = temp2 ;
	movab -2(r4),4(r3) # ??? re-pointed to mark field
#     Ltemp2        = Rparent ;
#     temp_spine -= 2;
	movl *(sp)+,(r4)
#     Ltemp3 = Rme ;
	movl 4(sp),r7     # r7 now points to root node
#     Rtemp2  = Rtemp3  = Rparent ;
	movl (r7),r0
	movl r0,4(r4)
	movl *(sp),(r5)
	movl r0,4(r5)
#     Lparent.child = temp1 ;
	movab -2(r3),-4(r7)     # ??? re-pointed to mark field
#     Rparent.child = temp3 ;
	movab -2(r5),(r7)       # ??? re-pointed to mark field
#     *(spine_stack) = temp1+1;
	movab 4(r3),(sp)
#     continue;
#  ??? write flush not required -- sp update flushed the node
#	movl r0,_nodea  # ?? flush write buffer
	jmp (r9)

#______________________________________________________________________
#     case DO_B:
# --> garbage collection entry point
	.align 2
L24:
	pushab 0(sp)
	calls $1,_collect_garbage
	movl _next_free_node,r3
        movab HEAPSTRIDE*4(r3),r11
	jbr L25
#
# ------------> entry point here <------------------
	.align 2
	.byte 0
DO_B:
	incl r10
#     NEWNODE1;
	movl r11,r3
        movab HEAPSTRIDE*4(r11),r11
        cmpl r3,_heap_end
	jgequ L24
L25:
	movl (r3),r0	# -- Pre-touch heap node to prevent later misses
#     ip           = Rme ;
	movl *(sp)+,r9
#     Ltemp1       = Rparent  ;
	movl *(sp)+,(r3)
#     temp_spine -= 2;
#     Lme = ip ;
	movl (sp),r8
	movl r9,-4(r8)
#     Rtemp1       = Rme ;
	movl (r8),4(r3)
#     Rme.child = temp1 ;
	movab -2(r3),(r8)      # ?? re-point to mark field
#     continue;
	movl r0,_nodea  # ?? flush write buffer
	jmp (r9)

#______________________________________________________________________
#     case DO_BSTAR:
# --> garbage collection entry point
	.align 2
L27:
	pushab _nodeb
	pushab _nodea
	pushab 8(sp)
	calls $3,_newnode2_continue
	movl _nodea,r3
	movl _nodeb,r4
	movl _next_free_node,r11
	jbr L28
#
# ------------> entry point here <------------------
	.align 2
	.byte 0
DO_BSTAR:
	incl r10
#     NEWNODE2;
	movl r11,r3
        movab HEAPSTRIDE*4(r11),r4
	movab 2*HEAPSTRIDE*4(r11),r11
        cmpl r3,_heap_end
	jgequ L27

L28:
	movl (r3),r0	# -- Pre-touch heap node to prevent later misses
#     ip           = Rme  ;
	movl *(sp)+,r9
#     Ltemp1       = Rparent ;
	movl *(sp)+,(r3)
#     Rtemp1.child = temp2 ;
	movab -2(r4),4(r3)   # ??? re-pointed to mark field
#     spine_stack -= 2 ;
#     Ltemp2       = Rme ;
	movl *(sp)+,(r4)
#     Rtemp2       = Rparent ;
	movl (sp),r8
	movl (r8),4(r4)
#     Lparent      = ip ;
	movl r9,-4(r8)
#     Rparent.child = temp1 ;
	movab -2(r3),(r8)   # ??? re-pointed to mark field
#     spine_stack -= 1 ;
#     continue ;
	movl r0,_nodea  # ?? flush write buffer
	jmp (r9)

#______________________________________________________________________
#     case DO_C:
# --> garbage collection entry point
	.align 2
L31:
	pushab 0(sp)
	calls $1,_collect_garbage
	movl _next_free_node,r3
        movab HEAPSTRIDE*4(r3),r11
	jbr L32
#
# ------------> entry point here <------------------
	.align 2
	.byte 0
DO_C:
	incl r10
#     NEWNODE1
	movl r11,r3
        movab HEAPSTRIDE*4(r11),r11
        cmpl r3,_heap_end
	jgequ L31

L32:
	movl (r3),r0	# -- Pre-touch heap node to prevent later misses
#     Ltemp1        = ip              = Rme  ;
#     temp_spine -= 1;
#     Rtemp1        = Rparent ;
	movl *(sp)+,r9
	movl 4(sp),r7
	movl r9,(r3)
	movl (r7),4(r3)
#     Rparent       = Rme ;
	movl *(sp),(r7)
#     Lparent.child  = temp1 ;
	movab -2(r3),-4(r7)   # ?? re-point to mark field
#     *(spine_stack) = temp1+1 ;
	movab 4(r3),(sp)
#     continue ;
#  ??? write flush not required -- sp update flushed the node
#	movl r0,_nodea  # ?? flush write buffer
	jmp (r9)

#______________________________________________________________________
#     case DO_CPRIME:
# --> garbage collection entry point
	.align 2
L34:
	pushab _nodeb
	pushab _nodea
	pushab 8(sp)
	calls $3,_newnode2_continue
	movl _nodea,r3
	movl _nodeb,r4
	movl _next_free_node,r11
	jbr L35
#
# ------------> entry point here <------------------
	.align 2
	.byte 0
DO_CPRIME:
	incl r10
#     NEWNODE2;
	movl r11,r3
        movab HEAPSTRIDE*4(r11),r4
	movab 2*HEAPSTRIDE*4(r11),r11
        cmpl r3,_heap_end
	jgequ L34

L35:
	movl (r3),r0	# -- Pre-touch heap node to prevent later misses
#     Ltemp1       =  ip           = Rme  ;
	movl *(sp)+,r9
	movl r9,(r3)
#     Rtemp1.child = temp2 ;
	movab -2(r4),4(r3)   # ??? re-pointed to mark field
#     Ltemp2       = Rparent ;
	movl *(sp)+,(r4)
#     temp_spine -= 2;
#     Rtemp2       = Rparent ;
	movl 4(sp),r7      # r7 now points to rhs of subtree root node
	movl (r7),4(r4)
#     Lparent.child = temp1 ;
	movab -2(r3),-4(r7)   # ??? re-pointed to mark field
#     Rparent       = Rme ;
	movl *(sp),(r7)
#     *(spine_stack) = temp1+1 ;
	movab 4(r3),(sp)
#     continue ;
#  ??? write flush not required -- sp update flushed the node
#	movl r0,_nodea  # ?? flush write buffer
	jmp (r9)

#______________________________________________________________________
#     case DO_IF:
	.align 2
	.byte 0
DO_IF:
	incl r10
#     result = Evaluate(Rme);
    # --  	movl *(sp)+,r9
    # --	movab -4(sp),sp
	movl *(sp),r9
	jsb (r9)
	movab 4(sp),sp

#     temp_spine -= 1 ;
#       parent_spine = temp_spine - 1 ;
	movl 4(sp),r7          #  r7 now has address of parent

#     if (result.literal)
	tstl r1
	jeql L39    # if 1st parameter was true, leave node alone
#       { Rparent = Rme ;
	movl *(sp),(r7)
#       }
L39:
#     Lparent.comb = mapval(DO_I) ;
	movl $DO_I,-4(r7)   # ????
#     ip = Rparent ;
	movl (r7),r9
#     spine_stack -= 3;
	addl2 $8,sp
#     continue ;
	movl r0,_nodea  # ?? flush write buffer
	jmp (r9)

#______________________________________________________________________
#     case DO_LIT:
	.align 2
	.byte 0
DO_LIT:
	incl r10
#     result = Rme ;
#     spine_stack += 1 ;
	movl *(sp)+,r1
#     break ;
	rsb

#______________________________________________________________________
#     case DO_NL
	.align 2
	.byte 0
DO_NL:
	incl r10
#     printf("\n");
	pushab LC0
	calls $1,_printf
#     result.literal = NULL ;
	clrl r1
#     break;
	rsb

#______________________________________________________________________
#     case DO_FALSE:
#     case DO_ZERO:
#     result.literal = 0;
#     result.literal = FALSE;
#     break ;
	.align 2
	.byte 0
DO_FALSE:
DO_ZERO:
	incl r10
	clrl r1
	rsb

#______________________________________________________________________
#     case DO_TRUE:
#     case DO_ONE:
#     result.literal = TRUE ;
#     result.literal = 1 ;
	.align 2
	.byte 0
DO_TRUE:
DO_ONE:
	incl r10
	movl $1,r1
#     break ;
	rsb

#______________________________________________________________________
#     case DO_TWO:
#     result.literal = 2 ;
	.align 2
	.byte 0
DO_TWO:
	incl r10
	movl $2,r1
#     break ;
	rsb

#______________________________________________________________________
#     case DO_THREE:
#     result.literal = 3 ;
	.align 2
	.byte 0
DO_THREE:
	incl r10
	movl $3,r1
#     break ;
	rsb

#______________________________________________________________________
#     case DO_NIL:
#     result.literal = -131313 ;
#     break ;
	.align 2
	.byte 0
DO_NIL:
	incl r10
	movl $-131313,r1
#     break ;
	rsb

#______________________________________________________________________
#     case DO_NOT:
	.align 2
	.byte 0
DO_NOT:
	incl r10
#     result = Evaluate(Rme) ;
	movl *(sp),r9
	movab -4(sp),sp
	jsb (r9)
	movab 4(sp),sp

#     result.literal = ! result.literal ;
	clrl r0
	tstl r1
	jneq L47
	incl r0
L47:	movl r0,r1
	movl (sp)+,r7          #  r7 now has address of me node
#     spine_stack += 1 ;  (out of order, r7 need not be changed)
#     Lme.comb  = mapval(DO_LIT) ;
	movl $DO_LIT,-4(r7)
#     Rme = result ;
	movl r1,(r7)
#     break ;
	movl r0,_nodea  # ?? flush write buffer
	rsb

#______________________________________________________________________
#     case DO_ABS:
	.align 2
	.byte 0
DO_ABS:
	incl r10
#    Use_Me ;
#    result  = Evaluate(Rme,temp_spine) ;
	movl *(sp),r9
	movab -4(sp),sp
	jsb (r9)
	movab 4(sp),sp
#    Use_Me ;
	movl (sp),r8
#    if (result.literal < 0 )  result.literal = 0 - result.literal ;
	tstl r1
	jgeq L48A
	mnegl r1,r1
L48A:
#    Lme.comb    = do_lit_value.value.comb ;
	movl $DO_LIT,-4(r8)
#    Rme = result ;
	movl r1,(r8)
#    Pop_Spine(1) ;
	movab 4(sp),sp
#    break ;
	rsb

#______________________________________________________________________
#     case DO_PRINT:
	.align 2
	.byte 0
DO_PRINT:
	incl r10
#    Use_Me ;
#    result  = Evaluate(Rme,temp_spine) ;
	movl *(sp),r9
	movab -4(sp),sp
	jsb (r9)
	movab 4(sp),sp
#    Use_Me ;
	movl (sp),r8
#    Lme.comb    = do_lit_value.value.comb ;
	movl $DO_LIT,-4(r8)
#    Rme = result ;
	movl r1,(r8)
#    Pop_Spine(1) ;
	movab 4(sp),sp
#    printf(" %d",result.literal);
	pushl r1
	pushab LC1
	calls $2,_printf
	clrl r1
#    break ;
	rsb

#______________________________________________________________________
#     case DO_PLUS:
	.align 2
	.byte 0
DO_PLUS:
	incl r10
#     result = Evaluate(Rme) ;
	movl *(sp),r9
# -- leaves an open stack param
	jsb (r9)

#     resultb = Evaluate(Rparent);
	movl *4(sp),r9
	movl r1,(sp)
	jsb (r9)

#     result.literal = result.literal + resultb.literal ;
	addl2 (sp),r1
#       parent_spine = temp_spine - 1 ;
	movl 4(sp),r7          #  r7 now has address of parent
	movab 8(sp),sp
#     spine_stack += 2 ;  (out of order, r7 need not be changed)
#     Lparent.comb  = mapval(DO_LIT) ;
	movl $DO_LIT,-4(r7)
#     Rparent = result ;
	movl r1,(r7)
#     break ;
	movl r0,_nodea  # ?? flush write buffer
	rsb

#______________________________________________________________________
#     case DO_MINUS:
	.align 2
	.byte 0
DO_MINUS:
	incl r10
#     result = Evaluate(Rme) ;
# --	movl *(sp)+,r9
# --	movab -4(sp),sp
	movl *(sp),r9
	jsb (r9)
	movab 4(sp),sp

#     resultb = Evaluate(Rparent);
	movl *(sp),r9
	pushl r1
	jsb (r9)

#     result.literal = result.literal + resultb.literal ;
	mnegl r1,r1
	addl2 (sp),r1
	movab 8(sp),sp
#       parent_spine = temp_spine - 1 ;
	movl -4(sp),r7          #  r7 now has address of parent

#     spine_stack += 2 ;  (out of order, r7 need not be changed)
#     Lparent.comb  = mapval(DO_LIT) ;
	movl $DO_LIT,-4(r7)
#     Rparent = result ;
	movl r1,(r7)
#     break ;
	movl r0,_nodea  # ?? flush write buffer
	rsb

#_____________________________________________________________________
#   case DO_TIMES:
	.align 2
	.byte 0
DO_TIMES:
	incl r10
#     result = Evaluate(Rme) ;
# --	movl *(sp)+,r9
# --	movab -4(sp),sp
	movl *(sp),r9
	jsb (r9)
	movab 4(sp),sp

#     resultb = Evaluate(Rparent);
	movl *(sp),r9
	pushl r1
	jsb (r9)

#     result.literal = result.literal + resultb.literal ;
	mull2 (sp),r1
	movab 8(sp),sp
#       parent_spine = temp_spine - 1 ;
	movl -4(sp),r7          #  r7 now has address of parent
#     spine_stack += 2 ;  (out of order, r7 need not be changed)
#     Lparent.comb  = mapval(DO_LIT) ;
	movl $DO_LIT,-4(r7)
#     Rparent = result ;
	movl r1,(r7)
#     break ;
	movl r0,_nodea  # ?? flush write buffer
	rsb

#______________________________________________________________________
#     case DO_MOD:
	.align 2
	.byte 0
DO_MOD:
	incl r10
#     result = Evaluate(Rme) ;
# --	movl *(sp)+,r9
# --	movab -4(sp),sp
	movl *(sp),r9
	jsb (r9)
	movab 4(sp),sp

#     resultb = Evaluate(Rparent);
	movl *(sp),r9
	pushl r1
	jsb (r9)

#     result.literal = result.literal % resultb.literal ;
	movl (sp),r2
	divl3 r2,r1,r0
	mull2 r2,r0
	subl2 r0,r1
	movab 8(sp),sp
#       parent_spine = temp_spine - 1 ;
	movl -4(sp),r7          #  r7 now has address of parent
#     spine_stack += 2 ;  (out of order, r7 need not be changed)
#     Lparent.comb  = mapval(DO_LIT) ;
	movl $DO_LIT,-4(r7)
#     Rparent = result ;
	movl r1,(r7)
#     break ;
	movl r0,_nodea  # ?? flush write buffer
	rsb

#______________________________________________________________________
#     case DO_DIV:
	.align 2
	.byte 0
DO_DIV:
	incl r10
#     result = Evaluate(Rme) ;
# --	movl *(sp)+,r9
# --	movab -4(sp),sp
	movl *(sp),r9
	jsb (r9)
	movab 4(sp),sp

#     resultb = Evaluate(Rparent);
	movl *(sp),r9
	pushl r1
	jsb (r9)

#     result.literal = result.literal / resultb.literal ;
	movl (sp),r2
	divl3 r2,r1,r1
	movab 8(sp),sp
#       parent_spine = temp_spine - 1 ;
	movl -4(sp),r7          #  r7 now has address of parent
#     spine_stack += 2 ;  (out of order, r7 need not be changed)
#     Lparent.comb  = mapval(DO_LIT) ;
	movl $DO_LIT,-4(r7)
#     Rparent = result ;
	movl r1,(r7)
#     break ;
	movl r0,_nodea  # ?? flush write buffer
	rsb

#______________________________________________________________________
#     case DO_LESS:
	.align 2
	.byte 0
DO_LESS:
	incl r10
#     result = Evaluate(Rme) ;
# --	movl *(sp)+,r9
# --	movab -4(sp),sp
	movl *(sp),r9
	jsb (r9)
	movab 4(sp),sp

#     resultb = Evaluate(Rparent);
	movl *(sp),r9
	pushl r1
	jsb (r9)

#     result.literal = result.literal < resultb.literal ;
	clrl r0
	cmpl (sp),r1
	jgeq L57
	incl r0
L57:	movab 8(sp),sp
	movl r0,r1
#       parent_spine = temp_spine - 1 ;
	movl -4(sp),r7          #  r7 now has address of parent
#     spine_stack += 2 ;  (out of order, r7 need not be changed)
#     Lparent.comb  = mapval(DO_LIT) ;
	movl $DO_LIT,-4(r7)
#     Rparent = result ;
	movl r1,(r7)
#     break ;
	movl r0,_nodea  # ?? flush write buffer
	rsb

#______________________________________________________________________
#     case DO_GREAT:
	.align 2
	.byte 0
DO_GREAT:
	incl r10
#     result = Evaluate(Rme) ;
# --	movl *(sp)+,r9
# --	movab -4(sp),sp
	movl *(sp),r9
	jsb (r9)
	movab 4(sp),sp

#     resultb = Evaluate(Rparent);
	movl *(sp),r9
	pushl r1
	jsb (r9)

#     result.literal = result.literal > resultb.literal ;
	clrl r0
	cmpl (sp),r1
	jleq L59
	incl r0
L59:
	movab 8(sp),sp
	movl r0,r1
#       parent_spine = temp_spine - 1 ;
	movl -4(sp),r7          #  r7 now has address of parent
#     spine_stack += 2 ;  (out of order, r7 need not be changed)
#     Lparent.comb  = mapval(DO_LIT) ;
	movl $DO_LIT,-4(r7)
#     Rparent = result ;
	movl r1,(r7)
#     break ;
	movl r0,_nodea  # ?? flush write buffer
	rsb

#______________________________________________________________________
#     case DO_EQ:
	.align 2
	.byte 0
DO_EQ:
	incl r10
#     result = Evaluate(Rme) ;
# --	movl *(sp)+,r9
# --	movab -4(sp),sp
	movl *(sp),r9
	jsb (r9)
	movab 4(sp),sp

#     resultb = Evaluate(Rparent);
	movl *(sp),r9
	pushl r1
	jsb (r9)

#     result.literal = result.literal == resultb.literal ;
	clrl r0
	cmpl (sp),r1
	jneq L61
	incl r0
L61:
	movab 8(sp),sp
	movl r0,r1
#       parent_spine = temp_spine - 1 ;
	movl -4(sp),r7          #  r7 now has address of parent
#     spine_stack += 2 ;  (out of order, r7 need not be changed)
#     Lparent.comb  = mapval(DO_LIT) ;
	movl $DO_LIT,-4(r7)
#     Rparent = result ;
	movl r1,(r7)
#     break ;
	movl r0,_nodea  # ?? flush write buffer
	rsb

#______________________________________________________________________
#     case DO_AND:
	.align 2
	.byte 0
DO_AND:
	incl r10
#     Use_Me ;
#     result = Evaluate(Rme,temp_spine) ;
	movl *(sp),r9
# -- leaves an open stack param
	jsb (r9)
#     if(result.literal)
	tstl r1
	jeql DO_AND1   # if false, leave false in result register
#       { Use_Parent;
	movl 4(sp),r7
#         resultb = Evaluate(Rparent,temp_spine);
	movl (r7),r9
	jsb (r9)
	tstl r1
	jeql DO_AND1   # if false, leave false in result register
#         if (resultb.literal) result.literal = TRUE ;
#         else    result.literal = FALSE ;
	movl $1,r1
#       }
#       else    result.literal = FALSE ;
DO_AND1:

#     Use_Parent;
	movl 4(sp),r7
#     Rparent = result ;
#     Lparent.comb = do_lit_value.value.comb ;
	movl $DO_LIT,-4(r7)
	movl r1,(r7)
#     Pop_Spine(2) ;
	movab 8(sp),sp
#     break ;
	movl r0,_nodea  # ?? flush write buffer
	rsb

#______________________________________________________________________
#     case DO_OR:
	.align 2
	.byte 0
DO_OR:
	incl r10
#     Use_Me ;
#     result = Evaluate(Rme,temp_spine) ;
	movl *(sp),r9
# -- leaves an open stack param
	jsb (r9)
#     if(!result.literal)
	tstl r1
	jneq DO_OR1   # if true, leave true in result register
#       { Use_Parent;
	movl 4(sp),r7
#         resultb = Evaluate(Rparent,temp_spine);
	movl (r7),r9
	jsb (r9)
	tstl r1
#         if (!resultb.literal) result.literal = FALSE ;
#         else    result.literal = TRUE ;
#       }
#       else    result.literal = TRUE ;
	jeql DO_OR2   # if false, leave false in result register
DO_OR1:
	movl $1,r1

DO_OR2:
#     Use_Parent;
	movl 4(sp),r7
#     Rparent = result ;
#     Lparent.comb = do_lit_value.value.comb ;
	movl $DO_LIT,-4(r7)
	movl r1,(r7)
#     Pop_Spine(2) ;
	movab 8(sp),sp
#     break ;
	movl r0,_nodea  # ?? flush write buffer
	rsb

#______________________________________________________________________
#     case DO_P:
	.align 2
	.byte 0
DO_P:
	incl r10
#     /*  P returns the address of the parent node RHS as its
#      *  result.  Also, all I-nodes between the parent and
#      *  me nodes are shorted by re-writing Lparent.
#      * 1) comparisons can compare on this address.
#      * 2) The U operator can then look at the result & LHS
#      */
#     Use_Parent;
	movl 4(sp),r7
#     Use_Me ;
	movl (sp),r8
#     result.child = parent_ptr - 1 ;
	movab -4(r7),r1
#     Lparent.child = FUDGE(me_ptr - 1);
	movab -6(r8),-4(r7)
#     Pop_Spine(2);
	movab 8(sp),sp
#     break ;
	movl r0,_nodea  # ?? flush write buffer
	rsb

#______________________________________________________________________
#     case DO_U:
# --> garbage collection entry point
	.align 2
DO_U_G:
	pushab 0(sp)
	calls $1,_collect_garbage
	movl _next_free_node,r3
        movab HEAPSTRIDE*4(r3),r11
	jbr DO_U_CONT
#
# ------------> entry point here <------------------
	.align 2
	.byte 0
DO_U:
	incl r10
#     NEWNODE1
	movl r11,r3
        movab HEAPSTRIDE*4(r11),r11
        cmpl r3,_heap_end
	jgequ DO_U_G

DO_U_CONT:
	movl (r3),r0	# -- Pre-touch heap node to prevent later misses
#     /* Evaluate Rparent subtree.  That subtree's P combinator
#      * will return pointer to RHS of node, and guarantee that
#      * the LHS of that node points to the node whose RHS
#      * contains the other pair parameter.
#      */
#     Use_Parent;
	movl 4(sp),r7
#     /* use temp2 as a scratch pointer to the P subtree */
#     /* apparent bug in TURBOC won't allow   temp2 = Evaluate(...).ptr ; */
#     result = Evaluate(Rparent,temp_spine) ;
	movl (r7),r9
	movab -4(sp),sp    # dummy entry for garbage collection
	jsb (r9)
	movab 4(sp),sp
#     temp2 = result.ptr ;      # just use r1
#     Use_Parent ;
	movl 4(sp),r7
#     Use_Me ;
	movl (sp),r8
#     Lparent.child = FUDGE(temp1) ;
	movab -2(r3),-4(r7)
#     Rparent = Rtemp2 ;
	movl 4(r1),(r7)
#     Ltemp1 = ip     = Rme ;
	movl (r8),r9
	movl r9,(r3)
#     Rtemp1          = (UNFUDGE(Ltemp2.child)+1)->value ;
	movl (r1),r0
	movl 6(r0),4(r3)
#     *(temp_spine) = temp1+1 ;
	movab 4(r3),(sp)
#     continue ;
#  ??? write flush not required -- sp update flushed the node
#	movl r0,_nodea  # ?? flush write buffer
	jmp (r9)

#______________________________________________________________________
# 
#    case SPINEUNDERFLOW: printf("\n\n spine stack underflow\n");
#       exit(-1);
	.align 2
	.byte 0
SPINE_UNDER:
	pushab LC2
	calls $1,_printf
	mnegl $1,-(sp)
	calls $1,_exit
	jbr TEMPRSB
#______________________________________________________________________
#    default: printf("\n\n jump to bad combinator\n");
#       exit(-1);
#    }
	.align 2
	.byte 0
BAD_COMBINATOR:
	pushab LC3
	calls $1,_printf
	mnegl $1,-(sp)
	calls $1,_exit
	jbr TEMPRSB
#______________________________________________________________________
#     return(result);
#   }
#     while ( TRUE ) ;
#     return(result);
#   }
L9:

#  ensure that temp_spine is maintained
TEMPRSB:
	movl	_next_free_node,r11
	movl	_spine_stack,r8
	rsb

#______________________________________________________________________
# int mapval(int toknum )
#   {  return(toknum);}
# /*  this translates token integers to execution addresses */
	.align 1
.globl _mapval
_mapval:
	.word 0x0
	movl 4(ap),r0
	addl2 r0,r0
	addl2 r0,r0
	jcc Lmap2
	movl $END_TABLE-TABLE,r0
Lmap2:
	movab TABLE(r0),r0
	cmpl r0,$END_TABLE
	jlss Lmap1
	movl $END_TABLE,r0
Lmap1:
	movl (r0),r0
	ret

#   NOTE:  all entry points are constrained to be aligned as
#           evenly divisible by 4 + 1
	.align 2
	.long BAD_COMBINATOR  # 
	.long BAD_COMBINATOR  # 
TABLE:
	.long BAD_COMBINATOR  #    #0th elemen
	.long DO_I  # 1 
	.long DO_K  # 2 
	.long DO_S  # 3 
	.long DO_SPRIME  # 4 
	.long DO_B  # 5 
	.long DO_C  # 6 
	.long DO_IF  # 7 
	.long DO_LIT  # 8 
	.long DO_PLUS  # 9 
	.long DO_MINUS  # 10 
	.long DO_LESS  # 11
	.long DO_TIMES  # 12
	.long DO_ONE  # 13
	.long DO_ZERO  # 14
	.long DO_EQ  # 15
	.long DO_GREAT  # 16
	.long DO_P  # 17
	.long DO_U  # 18
	.long BAD_COMBINATOR  # 19
	.long DO_NOT  # 20
	.long DO_ABS  # 21
	.long DO_ONE  # 22
	.long DO_ZERO  # 23
	.long DO_NIL  # 24
	.long DO_PRINT  # 25
	.long DO_NL  # 26
	.long BAD_COMBINATOR    # DO_AND  # 27
	.long BAD_COMBINATOR    # DO_OR  # 28
	.long DO_MOD       # 29
	.long DO_BSTAR     # 30
	.long DO_CPRIME    # 31
	.long DO_TWO       # 32
	.long DO_THREE     # 33
	.long DO_DIV       # 34
	.long SPINE_UNDER  # 35
	.long BAD_COMBINATOR  # 
	.long BAD_COMBINATOR  # 
	.long BAD_COMBINATOR  # 
	.long BAD_COMBINATOR  # 
	.long BAD_COMBINATOR  # 
	.long BAD_COMBINATOR  # 
	.long BAD_COMBINATOR  # 
	.long BAD_COMBINATOR  # 
	.long BAD_COMBINATOR  # 
	.long BAD_COMBINATOR  # 
	.long BAD_COMBINATOR  # 
	.long BAD_COMBINATOR  # 

	.long BAD_COMBINATOR  # 
	.long BAD_COMBINATOR  # 
	.long BAD_COMBINATOR  # 
	.long BAD_COMBINATOR  # 
	.long BAD_COMBINATOR  # 
END_TABLE:
	.long BAD_COMBINATOR  # 
	.long BAD_COMBINATOR  # 
	.long BAD_COMBINATOR  # 
	.long BAD_COMBINATOR  # 
	.long BAD_COMBINATOR  # 


	.align 1
.globl _init_map
_init_map:
	.word 0xff0
	ret



.text
	.align 0
LC0:
	.ascii "\12\0"
	.align 0
LC1:
	.ascii " %d\0"
	.align 0
LC2:
	.ascii "\12\12 spine stack underflow\12\0"
	.align 0
LC3:
	.ascii "\12\12 jump to bad combinator\12\0"
	.align 1

